package com.bpcl.lpg.core.service.impl;

import org.apache.commons.lang.StringUtils;
import java.util.Objects;
import java.net.http.HttpResponse;
import com.bpcl.lpg.core.service.BpclHttpClientService;
import de.hybris.platform.servicelayer.config.ConfigurationService;
import com.bpcl.lpg.core.service.LpgGetRequestService;

public class LpgGetRequestServiceImpl implements LpgGetRequestService
{
    private static final String URL_APPENDER = "?";
    private ConfigurationService configurationService;
    private BpclHttpClientService httpClientService;
    
    public HttpResponse<String> prepareAndExecuteGetRequest(final String endPointName, final String paramAsString) {
        Objects.requireNonNull(endPointName, "Get request endPoint name should not be null");
        final String uri = this.getEndPoint(endPointName, paramAsString);
        return this.getHttpClientService().executeGetMethod(uri);
    }
    
    private String getEndPoint(final String endPointName, final String paramAsString) {
        final String endpointUri = this.getConfigurationService().getConfiguration().getString(endPointName);
        Objects.requireNonNull(endpointUri, "Endpoint should not be null");
        return StringUtils.isBlank(paramAsString) ? endpointUri : endpointUri.concat("?").concat(paramAsString);
    }
    
    public ConfigurationService getConfigurationService() {
        return this.configurationService;
    }
    
    public void setConfigurationService(final ConfigurationService configurationService) {
        this.configurationService = configurationService;
    }
    
    public BpclHttpClientService getHttpClientService() {
        return this.httpClientService;
    }
    
    public void setHttpClientService(final BpclHttpClientService httpClientService) {
        this.httpClientService = httpClientService;
    }
}
